// ***************************************
// Plugin Application Class for SourceBoost IDE
// 
// Author(s): David Hobday
//
// Copyright (C) 2003-2010 Pavel Baranov
// Copyright (C) 2003-2010 David Hobday
// 
// This code may be freely used to develop
// Plugins for the SourceBoost IDE
// ***************************************

#include "stdafx.h"
#include "PluginApp.h"
#include "PluginConfigureDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(CPluginApp, CWinApp)
	//{{AFX_MSG_MAP(CPluginApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPluginApp construction

CPluginApp::CPluginApp()
{
	view = NULL;
	theViewParent = NULL;
}

HWND CPluginApp::CreateView( HWND parent )
{

	// If deriving CFormView - which is handy so a dialog can be created,
	// our view can't have IDE as direct parent, so create intermediate
	CWnd* view = NULL; CRect rt;
	CWnd wndParent; wndParent.Attach( parent );
	wndParent.GetClientRect( rt );
	
	theViewParent = new CStaticAutoSize;
	if ( theViewParent->Create( NULL, WS_VISIBLE , rt, &wndParent ) )
	{			
		view = CreateFormView( theViewParent );
		
		// attatch new view to parent
		if ( view )
			theViewParent->SetChild( view );
	}
	wndParent.Detach();

	// view creation failed - cleanup
	if ( view == NULL )
	{
		delete theViewParent;
		theViewParent = NULL;
	}
	return theViewParent?theViewParent->m_hWnd:NULL;
}

CWnd* CPluginApp::CreateFormView( CWnd* parent )
{
	CRect rt;
	parent->GetClientRect( rt );

	view = new CPluginView;
	
	if  ( FALSE == view->Create( NULL, _T("PluginWindow"), WS_CHILD | WS_VISIBLE, rt, parent, IDD_PLUGIN_FORMVIEW, NULL ) )
	{
		// creation failed
		delete view;
		view = NULL;
	}

	return view;
}


BOOL CPluginApp::DestroyView( void )
{
	delete view;
	view = NULL; // prevent temptation to reference in destructor
	delete theViewParent;
	theViewParent = NULL; // prevent temptation to reference in destructor
	return TRUE;
}

const TCHAR* CPluginApp::Name() const
{
	return _T("MyPlugin");
}

void CPluginApp::Configure( HWND parent )
{
	CWnd wndParent; wndParent.Attach( parent );
	CPluginConfigureDlg dlg( &wndParent );

	// get current pin name
	data.GetPinName( dlg.m_pinName );

	if( IDOK == dlg.DoModal() )
	{		
		// set new pin
		data.SetPinName( dlg.m_pinName );
		
		// no need to disconnect here, making a connect automatically disconnects first
		data.Connect();
	}
	wndParent.Detach();
}
